package
{
	import away3d.extrusions.Elevation;
	import away3d.lights.DirectionalLight;
	import away3d.materials.TextureMaterial;
	import away3d.materials.lightpickers.StaticLightPicker;
	import away3d.materials.methods.FogMethod;
	import away3d.textures.BitmapTexture;

	import com.blitting.display.Away3dFirstPersonViewport;
	import com.blitting.renderers.RandomTerrainHeightMap;

	import flash.display.BitmapData;

	[SWF(percentWidth = 100, percentHeight = 100, backgroundColor = 0x0, frameRate = 60)]
	public class Away3dFirstPersonViewportExample extends Away3dFirstPersonViewport
	{

		//------------------------------
		//  model
		//------------------------------

		protected var sunLight:DirectionalLight;

		protected var lightPicker:StaticLightPicker;

		protected var heightMapData:BitmapData;

		protected var terrainMaterial:TextureMaterial;

		protected var terrain:Elevation;


		//------------------------------
		//  lifecycle
		//------------------------------

		public function Away3dFirstPersonViewportExample()
		{
			super();

			walkIncrement = 200;
			strafeIncrement = 200;
		}

		override protected function initializeCamera():void
		{
			super.initializeCamera();

			camera.lens.far = 150000;
			camera.lens.near = .05;
		}

		override protected function initializeLights():void
		{
			super.initializeLights();

			sunLight = new DirectionalLight(-300, -300, -500);
			sunLight.color = 0xfffdc5;
			sunLight.ambient = 1;
			view.scene.addChild(sunLight);

			lightPicker = new StaticLightPicker([ sunLight ]);
		}

		override protected function initializeMaterials():void
		{
			super.initializeMaterials();

			heightMapData = new RandomTerrainHeightMap();
			terrainMaterial = new TextureMaterial(new BitmapTexture(heightMapData));
			terrainMaterial.addMethod(new FogMethod(0, 200000, 0x000000));
			terrainMaterial.lightPicker = lightPicker;
		}

		override protected function initializeObjects():void
		{
			super.initializeObjects();

			terrain = new Elevation(terrainMaterial, heightMapData, 200000, 50000, 200000, 65, 65);
			view.scene.addChild(terrain);

			targetObject = camera;
			lookAtObject = terrain;
		}

		override public function prerender():void
		{
			super.prerender();

			camera.y += 0.4 * (terrain.getHeightAt(camera.x, camera.z) + 500 - camera.y);
		}

	}
}
