package
{
	import away3d.entities.Mesh;
	import away3d.lights.DirectionalLight;
	import away3d.materials.ColorMaterial;
	import away3d.materials.lightpickers.StaticLightPicker;
	import away3d.materials.methods.FilteredShadowMapMethod;
	import away3d.primitives.CubeGeometry;

	import com.blitting.constant.ColorPalette;
	import com.blitting.core.blitting_internal;
	import com.blitting.display.Away3dHoverViewport;

	use namespace blitting_internal;

	[SWF(percentWidth = 100, percentHeight = 100, backgroundColor = 0x0, frameRate = 60)]
	public class Away3dHoverViewportExample extends Away3dHoverViewport
	{

		//------------------------------
		//  model
		//------------------------------

		protected var material:ColorMaterial;

		protected var cube:Mesh;

		protected var sunLight:DirectionalLight;

		protected var lightPicker:StaticLightPicker;


		//------------------------------
		//  lifecycle
		//------------------------------

		public function Away3dHoverViewportExample()
		{
			super();
		}

		override protected function initializeCamera():void
		{
			super.initializeCamera();

			camera.lens.far = 10000;
			camera.lens.near = 50;

			cameraController.distance = 1000;
		}

		override protected function initializeLights():void
		{
			super.initializeLights();

			sunLight = new DirectionalLight(-300, -300, -500);
			sunLight.color = 0xfffdc5;
			sunLight.ambient = 1;
			view.scene.addChild(sunLight);

			lightPicker = new StaticLightPicker([ sunLight ]);
		}

		override protected function initializeMaterials():void
		{
			super.initializeMaterials();

			material = new ColorMaterial(ColorPalette.oliveDrab4);
			material.shadowMethod = new FilteredShadowMapMethod(sunLight);
			material.lightPicker = lightPicker;
		}

		override protected function initializeObjects():void
		{
			super.initializeObjects();

			cube = new Mesh(new CubeGeometry(400, 400, 400), material);
			cube.castsShadows = true;
			view.scene.addChild(cube);

			targetObject = camera;
			lookAtObject = cube;
		}

	}
}
