package
{
	import away3d.primitives.SkyBox;
	import away3d.textures.BitmapCubeTexture;
	import away3d.utils.Cast;

	import com.blitting.display.Away3dHoverViewport;

	[SWF(percentWidth = 100, percentHeight = 100, backgroundColor = 0x0, frameRate = 60)]
	public class Away3dSkyBoxExample extends Away3dHoverViewport
	{

		//------------------------------
		//  constant
		//------------------------------

		[Embed(source = "assets/skybox/space/space_posX.jpg")]
		protected static const EnvPosX:Class;

		[Embed(source = "assets/skybox/space/space_posY.jpg")]
		protected static const EnvPosY:Class;

		[Embed(source = "assets/skybox/space/space_posZ.jpg")]
		protected static const EnvPosZ:Class;

		[Embed(source = "assets/skybox/space/space_negX.jpg")]
		protected static const EnvNegX:Class;

		[Embed(source = "assets/skybox/space/space_negY.jpg")]
		protected static const EnvNegY:Class;

		[Embed(source = "assets/skybox/space/space_negZ.jpg")]
		protected static const EnvNegZ:Class;


		//------------------------------
		//  model
		//------------------------------

		protected var cubeTexture:BitmapCubeTexture;


		//------------------------------
		//  lifecycle
		//------------------------------

		public function Away3dSkyBoxExample()
		{
			super();
		}

		override protected function initializeMaterials():void
		{
			super.initializeMaterials();

			cubeTexture = new BitmapCubeTexture(Cast.bitmapData(EnvPosX),
												Cast.bitmapData(EnvNegX),
												Cast.bitmapData(EnvPosY),
												Cast.bitmapData(EnvNegY),
												Cast.bitmapData(EnvPosZ),
												Cast.bitmapData(EnvNegZ));
		}

		override protected function initializeObjects():void
		{
			super.initializeObjects();

			scene.addChild(new SkyBox(cubeTexture));
		}

	}
}
